libstdc++: std::atomic< unsigned long > Struct Reference

libstdc++

std::atomic< unsigned long > Struct Reference
Atomics

`#include <atomic>`

## Public Types
typedef __atomic_base< unsigned long > | __base_type
typedef unsigned long | __integral_type
using | value_type

## Public Member Functions
constexpr | atomic (__integral_type __i) noexcept
| atomic (const atomic &)=delete
bool | compare_exchange_strong (unsigned long &__e, unsigned long __i, memory_order __s, memory_order __f) noexcept
bool | compare_exchange_weak (unsigned long &__e, unsigned long __i, memory_order __s, memory_order __f) noexcept
unsigned long | exchange (unsigned long __i, memory_order __m=memory_order_seq_cst) noexcept
bool | is_lock_free () const noexcept
unsigned long | load (memory_order __m=memory_order_seq_cst) const noexcept
| operator unsigned long () const noexcept
| operator unsigned long () const volatile noexcept
atomic & | operator= (const atomic &) volatile =delete
atomic & | operator= (const atomic &)=delete
void | store (unsigned long __i, memory_order __m=memory_order_seq_cst) noexcept

## Detailed Description

Explicit specialization for unsigned long.

Definition at line 933 of file atomic.

## Member Typedef Documentation

## ◆ __base_type

typedef __atomic_base<unsigned long> std::atomic< unsigned long >::__base_type

Definition at line 936 of file atomic.

## ◆ __integral_type

typedef unsigned long std::atomic< unsigned long >::__integral_type

Definition at line 935 of file atomic.

## ◆ value_type

using std::atomic< unsigned long >::value_type

Definition at line 202 of file atomic.

## Constructor & Destructor Documentation

## ◆ atomic()

std::atomic< unsigned long >::atomic | ( | __integral_type | __i | ) |
| inlineconstexprnoexcept

Definition at line 944 of file atomic.

## Member Function Documentation

## ◆ compare_exchange_strong()

bool std::atomic< unsigned long >::compare_exchange_strong | ( | unsigned long & | __e,
|  | unsigned long | __i,
|  | memory_order | __s,
|  | memory_order | __f )
| inlinenoexcept

Definition at line 383 of file atomic.

## ◆ compare_exchange_weak()

bool std::atomic< unsigned long >::compare_exchange_weak | ( | unsigned long & | __e,
|  | unsigned long | __i,
|  | memory_order | __s,
|  | memory_order | __f )
| inlinenoexcept

Definition at line 355 of file atomic.

## ◆ exchange()

unsigned long std::atomic< unsigned long >::exchange | ( | unsigned long | __i,
|  | memory_order | __m = memory_order_seq_cst )
| inlinenoexcept

Definition at line 332 of file atomic.

## ◆ is_lock_free()

bool std::atomic< unsigned long >::is_lock_free | ( |  | ) | const
| inlinenoexcept

Definition at line 277 of file atomic.

## ◆ load()

unsigned long std::atomic< unsigned long >::load | ( | memory_order | __m = memory_order_seq_cst | ) | const
| inlinenoexcept

Definition at line 314 of file atomic.

## ◆ operator unsigned long() [1/2]

std::atomic< unsigned long >::operator unsigned long | ( |  | ) | const
| inlinenoexcept

Definition at line 262 of file atomic.

## ◆ operator unsigned long() [2/2]

std::atomic< unsigned long >::operator unsigned long | ( |  | ) | const volatile
| inlinenoexcept

Definition at line 265 of file atomic.

## ◆ store()

void std::atomic< unsigned long >::store | ( | unsigned long | __i,
|  | memory_order | __m = memory_order_seq_cst )
| inlinenoexcept

Definition at line 298 of file atomic.

The documentation for this struct was generated from the following file:

- atomic